import pgzrun
import sys

TITLE = 'Knight Jumping Game'
WIDTH = 900
HEIGHT = 554

hero = Actor('knightbig_small')
enemy = Actor('evil_wizard2_small')

hero.score= 0

hero.pos=(400, 470)
enemy.pos=(900, 460)
enemy.difficulty = 3
hero.earnpoint = True
hero.grounded = True
hero.impluse = 0
game_state = ['game', 'gameover']
game_current_state = game_state[0]


#draws background
def draw_background():
    screen.blit('bgfinal' , (0,0))

def draw_characters():
   hero.draw()
   enemy.draw()

def update(dt):
    global hero
    global enemy
    global game_current_state
    global game_state
   
    if game_current_state == game_state[0]:
        enemy.x -= enemy.difficulty
               
        if enemy.x < WIDTH - 900:
            enemy.x = 900
            hero.earnpoint = True
                   
           
        if hero.x > enemy.x and hero.earnpoint:
            hero.score += 1
            hero.earnpoint = False
    
    if game_current_state == game_state[1]:
        screen.draw.text(f"GAME OVER! Your final score is {hero.score}", center=(WIDTH-450, HEIGHT-277))
    
    
    player_movement(dt)      
    ground_check(dt)
    check_collision()
       
def ground_check(dt):
    global hero
    global game_current_state
    global game_state
   
    if game_current_state == game_state[0]:
   
        if hero.y < 470:
            hero.grounded = False
       
        if hero.y > 470:
            hero.y = 470
            hero.grounded = True
       
def draw():
    draw_background()
    draw_characters()
    screen.draw.text(f"Score: {hero.score}", topright=(WIDTH-25, HEIGHT-520))

def player_movement(dt):
    global hero
    global game_current_state
    global game_state
    if game_current_state == game_state[0]:
   
        if not hero.grounded:
            hero.impluse -= 15
            hero.y -= dt * hero.impluse

def on_key_down(key):
    global hero
    global game_current_state
    global game_state

    if game_current_state == game_state[0]:
        if key == keys.UP and hero.grounded:
            hero.grounded = False
            hero.impluse = 560

    if key == keys.ESCAPE:
        sys.exit()
       
def check_collision():
    global hero
    global enemy
    global game_current_state
    global game_state
   
    if hero.colliderect(enemy) and game_current_state == game_state[0]:
        game_current_state = game_state[1]
        clock.unschedule(difficulty_increase)


def difficulty_increase():
    global enemy
    enemy.difficulty *= 1.2

clock.schedule_interval(difficulty_increase, 5)

pgzrun.go()